/*
    Title:    AVR-GCC test program #7 for the STK200 eva board
    Authors:  Pieter Conradie, Volker Oth
    Date:     9/1999
    Purpose:  Demonstrates simple printing to and reading from the UART
    needed
    Software: AVR-GCC to compile
    needed
    Hardware: ATs90s08515/8535/Mega603 on STK200/300 board
    Note:     To contact me, mail to
                  volkeroth@gmx.de
              You might find more AVR related stuff at my homepage:
                  http://members.xoom.com/volkeroth
*/

#include "uart.h"
#include <avr/pgmspace.h>
#include <avr/io.h>
#include "timer.h"
#include "UartPrintF.h"

int main(void)
{
    double a1=1.234, a2=2.756, a=0.0;
	int i;
	
	u08 data;
	u16 ticks1,ticks2;                      /* timer 1 ticks needed for sqrt */
	
	timer_init();                   /* init timer1 */
    
	/* Initialise UART */
    UART_Init();

    PRINT("Hello World !");
    EOL();

    for (;;) {  /* loop forever */
        UartPrintF("Press any key...");
        EOL();
		
		ticks1 = TCNT1;   /* start measurement */
		//UartPrintF("Ticks1? %u\r\n",ticks1);
		
		//for(i=0;i<1000;i++)
			a = a1 * a2;	
		
    	ticks2 = TCNT1;   /* start measurement */
		UartPrintF("Ticks1? %u\r\n",ticks1);
		UartPrintF("Ticks2? %u\r\n",ticks2);
		UartPrintF("dTicks? %u us\r\n",(ticks2-ticks1)/4);

    
        data = UART_ReceiveByte();
    
        PRINT(" -> You pressed '");
        UART_SendByte(data);
        PRINT("' which is 0x");
        UART_Printfu08(data);
        PRINT(" in hexadecimal.");
        EOL();
    }
}
